<template>
  <div class="home">

    <router-link
      class="return_button"
      :to="{ name: 'home' }">
      <ArrowLeftIcon />
      <span>Device selection</span>
    </router-link>

    <div class="buttons_container">
      <button id="up" type="button" @click="command('up')">
        <ArrowUpIcon />
      </button>
      <button id="left" type="button" @click="command('left')">
        <ArrowLeftIcon />
      </button>
      <button id="right" type="button" @click="command('right')">
        <ArrowRightIcon />
      </button>
      <button id="down" type="button" @click="command('down')">
        <ArrowDownIcon />
      </button>
    </div>

    <div
      :class="{visible: !device_connected }"
      class="device_disconnected">
      Disconnected
    </div>







  </div>
</template>

<script>
// @ is an alias to /src
//import HelloWorld from '@/components/HelloWorld.vue'
import ArrowDownIcon from 'vue-material-design-icons/ArrowDown.vue'
import ArrowUpIcon from 'vue-material-design-icons/ArrowUp.vue'
import ArrowRightIcon from 'vue-material-design-icons/ArrowRight.vue'
import ArrowLeftIcon from 'vue-material-design-icons/ArrowLeft.vue'
import 'vue-material-design-icons/styles.css'

export default {
  name: 'Device',
  components: {
    ArrowDownIcon,
    ArrowUpIcon,
    ArrowRightIcon,
    ArrowLeftIcon
  },

  data(){
    return {

    }
  },

  methods: {
    command(command){
      const device_id = this.$route.params.id
      const url = `${process.env.VUE_APP_API_URL}/devices/${device_id}/command`
      this.axios.post(url, {command: command})
      .then(() => {})
      .catch((error) => {console.error(error)})
    }
  },
  computed: {
    device_connected(){
      return this.$store.state.devices.find(device => device.id === this.$route.params.id)
    }
  },

}
</script>

<style scoped>

.material-design-icon__svg {
  bottom: 0 !important;
}
.home {
  height: 100vh;
  position: relative;
  display: flex;
  justify-content: center;
  align-items: center;
}

.buttons_container {
  display: grid;
  grid-template-areas:
  '. up .'
  'left . right'
  '. down .';
  grid-template-columns: repeat(3, 25vmin);
  grid-template-rows: repeat(3, 25vmin);
}

#up {
  grid-area: up;
}

#right {
  grid-area: right;
}

#left {
  grid-area: left;
}

#down {
  grid-area: down;
}

button {
  padding: 0;
  border-radius: 100%;
  font-size: 8vmin;
  outline: none;
  background-color: white;
  transition: 0.1s;
  border: 1px solid #222222;
  //border: none;
  color: #222222;
  cursor: pointer;

  display: flex;
  align-items: center;
  justify-content: center;
  //box-shadow: 0 14px 28px rgba(0,0,0,0.25), 0 10px 10px rgba(0,0,0,0.22);

}

button:active{
  border-color: #c00000;
  background-color: #c00000;
  color: white;
  //box-shadow: 0 3px 6px rgba(0,0,0,0.16), 0 3px 6px rgba(0,0,0,0.23);
  -webkit-tap-highlight-color: transparent;
}


.return_button{
  position: absolute;
  color: currentcolor;
  text-decoration: none;
  display: flex;
  top: 0.5em;
  left: 0.25em;
  font-size: 150%;
  transition: 0.25s;
}

.return_button:hover {
  color: #c00000;
}

.return_button > *:not(:last-of-type) {
  margin-right: 0.25em;
}

.device_disconnected{
  position: absolute;
  top: 15%;
  padding: 0.5em;
  width: auto;
  z-index: 5;
  color: white;
  visibility: hidden;
  background-color: transparent;
  display: flex;
  align-items: center;
  justify-content: center;
  transition: 0.25s;
  font-size: 5vmin;
  border-radius: 0.5em;

}

.device_disconnected:not(.visible) {
  transition-delay: 0.5s;
}

.device_disconnected.visible {

  background-color: #444444aa;
  visibility: visible;
}

</style>
